
SetVerbose("EightDescent",2);
SetVerbose("Conic",2);
CDB := CremonaDatabase();

PRO := false;
NUM := 1;
COUNT := 0;

N_0 := 1309;
//N_0 := 10^5;
"Starting at conductor", N_0;

for N := N_0 to LargestConductor(CDB) do 
    for E in EllipticCurves(CDB,N) do
	if COUNT ge NUM then break N; end if;
	if
	    AnalyticRank(E) gt 0 or Round(ConjecturalRegulator(E)) mod 16 ne 0
	then
	    continue;
	end if;
        printf "E = %o, doing TwoDescent with seed = %o\n",
               CremonaReference(E), GetSeed();
	time td := TwoDescent(E : RemoveTorsion); 
	if #td ne 3 then continue; end if;
        C2 := Random(td);
        printf "E = %o, doing FourDescent on %o\n with seed = %o\n",
               CremonaReference(E), C2, GetSeed();
	time FD := FourDescent(C2 : RemoveTorsion);
        if #FD gt 0 then
	    COUNT +:= 1;
	    C4 := Random(FD);
	    printf "E = %o, doing EightDescent on C4 = %o\n with seed = %o\n", 
                   CremonaReference(E), C4, GetSeed();
            if PRO then ProfileReset(); SetProfile(true); end if;
	    time ed, edmaps := EightDescent(C4); 
            if PRO then SetProfile(false); ProfilePrintByTotalTime(:Max:=40); end if;
	end if;
    end for;
end for; 
