freeze;

intrinsic Order(A::AlgAssV[FldNum], m::AlgMatElt[FldNum], I::[ RngOrdFracIdl ])-> AlgAssVOrd, Map
{};

    require IsUnitary(A) : "Algebra must have a 1";

    AF := CoefficientRing(A);
    require AF eq CoefficientRing(m) : "Matrix must be over the same ring as the algebra";
    require Dimension(A) eq Degree(Parent(m)) : "Algebra and matrix have different dimensions";
    require Dimension(A) eq #I : "Number of ideals must be the dimension of the algebra";

    O := Order(I[1]);

    require NumberField(O) eq AF : "Coefficient rings must be compatible";
    F := FieldOfFractions(O);

    A, mp := ChangeRing(A, F);
    m := ChangeRing(Parent(m), F)!m;

    O := Order(A, m, I);
    O`ChangeRingMap := mp;
    return O, mp;

end intrinsic;

intrinsic Order(A::AlgAssV[FldNum], pm::PMat)-> AlgAssVOrd, Map
{Create the order of an algebra similiar to A with basis pm and return the map from A into the algebra of the order};

    require IsUnitary(A) : "Algebra must have a 1";

    AF := CoefficientRing(A);
    require Dimension(A) eq Length(pm) : "Algebra and pseudo-matrix have different dimensions";

    O := Order(pm);
    require AF eq NumberField(O) : "Matrix must be over the same ring as the algebra";
    F := FieldOfFractions(O);

    A, mp := ChangeRing(A, F);

    O := Order(A, pm);
    O`ChangeRingMap := mp;
    return O, mp;

end intrinsic;

