freeze;

/////////////////////////////////////////////////////////////////////////
// simplex.m
/////////////////////////////////////////////////////////////////////////
// $Revision: 39231 $
// $Date: 2012-07-13 05:16:06 +1000 (Fri, 13 Jul 2012) $
// $LastChangedBy: kasprzyk $
/////////////////////////////////////////////////////////////////////////
// Author: Alexander M Kasprzyk
/////////////////////////////////////////////////////////////////////////
// Calculates the Minkowski decompositions for a simplex.
/////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////
// Main function
/////////////////////////////////////////////////////////////////////////

// Returns the Minkowski decomposition of a simplex P.
function simplex_decomposition(P)
    // The only possibility is for P = mQ for a simplex Q
    verts:=Vertices(P);
    m:=GCD(&cat[PowerSequence(Integers()) | Eltseq(v) : v in verts]);
    if m eq 1 then
        return [[P]];
    else
        Q:=P / m;
        return [[Q : i in [1..m]]];
    end if;
end function;
