freeze;
 
family_names := [
"A", "B", "C", "D", "G", "F", "E", "E", "E", "2A", "2B", "2D", "3D", "2G",
"2F", "2E", "Alt", "Sporadic", "Cyclic"];

alt_names := [ "L", "O", "S", "O+", "", "", "", "", "", "U", "Sz", "O-",
"", "R", "R", "", "", "", ""];

sporadic_names := [ "M11", "M12",  "M22", "M23", "M24", "J1", "HS", "J2",
"McL", "Suz", "J3", "Co1", "Co2", "Co3", "He", "Fi22", "Fi23", "Fi24'",
"Ly", "Ru", "O'N", "Th", "HN", "B", "M", "J4"];

simple_name := function(tup)
    fn := family_names[tup[1]];
    an := alt_names[tup[1]];

    case tup[1]:
	when 19: name := &cat[fn, "(", IntegerToString(tup[3]), ")"];
	when 18: name := &cat[fn, " ", sporadic_names[tup[2]]];
	when 17:  name := &cat[fn, "(", IntegerToString(tup[2]), ")"];
	when 1: name := &cat[fn, "(", IntegerToString(tup[2]), ", ",
		    IntegerToString(tup[3]), ")"];
	when 2: name := &cat[fn, "(", IntegerToString(tup[2]), ", ",
		    IntegerToString(tup[3]), ")"];
	when 3: name := &cat[fn, "(", IntegerToString(tup[2]), ", ",
		    IntegerToString(tup[3]), ")"];
	when 4: name := &cat[fn, "(", IntegerToString(tup[2]), ", ",
		    IntegerToString(tup[3]), ")"];
	when 5: name := &cat[fn, "(2, ", IntegerToString(tup[3]), ")"];
	when 6: name := &cat[fn, "(4, ", IntegerToString(tup[3]), ")"];
	when 7: name := &cat[fn, "(6, ", IntegerToString(tup[3]), ")"];
	when 8: name := &cat[fn, "(7, ", IntegerToString(tup[3]), ")"];
	when 9: name := &cat[fn, "(8, ", IntegerToString(tup[3]), ")"];
	when 10: name := &cat[fn, "(", IntegerToString(tup[2]), ", ",
			IntegerToString(tup[3]), ")"];
	when 11: name := &cat[fn, "(2, ", IntegerToString(tup[3]), ")"];
	when 12: name := &cat[fn, "(", IntegerToString(tup[2]), ", ",
			IntegerToString(tup[3]), ")"];
	when 13: name := &cat[fn, "(4, ", IntegerToString(tup[3]), ")"];
	when 14: name := &cat[fn, "(2, ", IntegerToString(tup[3]), ")"];
	when 15: name := &cat[fn, "(4, ", IntegerToString(tup[3]), ")"];
		if tup[3] eq 2 then name cat:= "'"; end if;
	when 16: name := &cat[fn, "(6, ", IntegerToString(tup[3]), ")"];
    end case;

    if #an eq 0 then return name; end if;
    name cat:= &cat["[= ", an, "("];
    case tup[1]:
	when 1: name cat:= &cat[IntegerToString(tup[2]+1), ", ",
		    IntegerToString(tup[3])];
	when 2: name cat:= &cat[IntegerToString(2*tup[2]+1), ", ",
		    IntegerToString(tup[3])];
	when 3: name cat:= &cat[IntegerToString(2*tup[2]), ", ",
		    IntegerToString(tup[3])];
	when 4: name cat:= &cat[IntegerToString(2*tup[2]), ", ",
		    IntegerToString(tup[3])];
	when 10: name cat:= &cat[IntegerToString(tup[2]+1), ", ",
		    IntegerToString(tup[3])];
	when 12: name cat:= &cat[IntegerToString(2*tup[2]), ", ",
		    IntegerToString(tup[3])];
	else
	    name cat:= IntegerToString(tup[3]);
    end case;
    name cat:= ")]";

    return name;
end function;

simple_short_name := function(tup)
    fn := family_names[tup[1]];
    an := alt_names[tup[1]];

    case tup[1]:
	when 19: name := IntegerToString(tup[3]); // cyclic
	when 18: name := sporadic_names[tup[2]];
	when 17:  name := &cat["A(", IntegerToString(tup[2]), ")"];
	when 1: name := &cat[an, "(", IntegerToString(tup[2]+1), ",",
		    IntegerToString(tup[3]), ")"];
	when 2: name := &cat[an, "(", IntegerToString(2*tup[2]+1), ",",
		    IntegerToString(tup[3]), ")"];
	when 3: name := &cat[an, "(", IntegerToString(2*tup[2]), ",",
		    IntegerToString(tup[3]), ")"];
	when 4: name := &cat[an, "(", IntegerToString(2*tup[2]), ",",
		    IntegerToString(tup[3]), ")"];
	when 5: name := &cat[fn, "(2,", IntegerToString(tup[3]), ")"];
	when 6: name := &cat[fn, "(4,", IntegerToString(tup[3]), ")"];
	when 7: name := &cat[fn, "(6,", IntegerToString(tup[3]), ")"];
	when 8: name := &cat[fn, "(7,", IntegerToString(tup[3]), ")"];
	when 9: name := &cat[fn, "(8,", IntegerToString(tup[3]), ")"];
	when 10: name := &cat[an, "(", IntegerToString(tup[2]+1), ",",
		    IntegerToString(tup[3]), ")"];
	when 11: name := &cat[an, "(", IntegerToString(tup[3]), ")"];
	when 12: name := &cat[an, "(", IntegerToString(2*tup[2]), ",",
		    IntegerToString(tup[3]), ")"];
	when 13: name := &cat[fn, "(4,", IntegerToString(tup[3]), ")"];
	when 14: name := &cat[fn, "(2,", IntegerToString(tup[3]), ")"];
	when 15: name := &cat[fn, "(4,", IntegerToString(tup[3]), ")"];
		if tup[3] eq 2 then name cat:= "'"; end if;
	when 16: name := &cat[fn, "(6,", IntegerToString(tup[3]), ")"];
    end case;

    return name;
end function;

simple_grps_with_order_dividing := function(n)
    divs := Divisors(n);
    res := [];
    for d in divs do fl, tup := IsSimpleOrder(d);
	if fl then 

	    Append(~res, tup);

	    if d eq 20160 then
		if tup[1] eq 17 then Append(~res, <1, 2, 4>); 
	    else Append(~res, <17, 8, 0>); end if;
	    end if;

	    if tup[1] eq 2 and IsOdd(tup[3]) and tup[2] gt 2 then
		Append(~res, <3, tup[2], tup[3]>);
	    end if;

	    if tup[1] eq 3 and IsOdd(tup[3]) and tup[2] gt 2 then
		Append(~res, <2, tup[2], tup[3]>);
	    end if;

	end if;
    end for;
    return res;
end function;

simple_grps_with_order := function(n)
    res := [];
    fl, tup := IsSimpleOrder(n);
    if fl then 

	Append(~res, tup);

	if n eq 20160 then
	    if tup[1] eq 17 then Append(~res, <1, 2, 4>); 
	else Append(~res, <17, 8, 0>); end if;
	end if;

	if tup[1] eq 2 and IsOdd(tup[3]) and tup[2] gt 2 then
	    Append(~res, <3, tup[2], tup[3]>);
	end if;

	if tup[1] eq 3 and IsOdd(tup[3]) and tup[2] gt 2 then
	    Append(~res, <2, tup[2], tup[3]>);
	end if;

    end if;
    return res;
end function;

intrinsic SimpleGroupName(T::Tup) -> MonStgElt
{A name (and a possible alias) for the simple group specified by the tuple T. 
T is assumed to be a tuple as returned by IsSimpleOrder or as part of the 
sequence returned by CompositionFactors}

   return simple_name(T);
end intrinsic;

intrinsic SimpleGroupsWithOrderDividing(n::RngIntElt:IncludeCyclics:=false) ->
SeqEnum
{Returns a sequence of names for the simple groups that have order dividing n}

   if n le 1 then return []; end if; 

   Q := simple_grps_with_order_dividing(n);
   if IncludeCyclics then 
       return [simple_name(t): t in Q];
   else
       return [simple_name(t): t in Q | t[1] ne 19];
   end if;
end intrinsic;

intrinsic SimpleGroupsWithOrder(n::RngIntElt:IncludeCyclics:=false) ->
SeqEnum
{Returns a sequence of names for the simple groups that have order n}

   if n le 1 then return []; end if; 

   Q := simple_grps_with_order(n);
   if IncludeCyclics then 
       return [simple_name(t): t in Q];
   else
       return [simple_name(t): t in Q | t[1] ne 19];
   end if;
end intrinsic;

delete simple_name, simple_grps_with_order_dividing, family_names, alt_names,
sporadic_names, simple_grps_with_order;

sporadic_orders := [7920, 95040, 443520, 10200960, 244823040, 175560, 
44352000, 604800, 898128000, 448345497600, 50232960, 4157776806543360000,
42305421312000, 495766656000, 4030387200, 64561751654400, 4089470473293004800,
1255205709190661721292800, 51765179004000000, 145926144000, 460815505920,
90745943887872000, 273030912000000, 4154781481226426191177580544000000,
808017424794512875886459904961710757005754368000000000, 86775571046077562880];

simple_order := function(tup)
    case tup[1]: 
	when 19: return tup[3];
	when 18: return sporadic_orders[tup[2]];
	when 17: return Factorial(tup[2]) div 2;
	when 1: return (q^(n*(n+1) div 2) * &*[q^i-1:i in [2..n+1]]) div
		    Gcd(n+1, q-1) where q is tup[3] where n is tup[2];
	when 2: return (q^(n^2) * &*[q^i-1: i in [2..2*n by 2]]) div
		    Gcd(2, q-1) where q is tup[3] where n is tup[2];
	when 3: return (q^(n^2) * &*[q^i-1: i in [2..2*n by 2]]) div
		    Gcd(2, q-1) where q is tup[3] where n is tup[2];
	when 4: return (q^(n*(n-1))*(q^n - 1)* &*[q^i-1: i in [2..2*n-2 by 2]]) 
		    div Gcd(4, q^n-1) where q is tup[3] where n is tup[2];
	when 5: return q^6*(q^6-1)*(q^2-1) where q is tup[3];
	when 6: return q^24*(q^12-1)*(q^8-1)*(q^6-1)*(q^2-1) where q is tup[3];
	when 7: return q^36*(q^12-1)*(q^9-1)*(q^8-1)*(q^6-1)*(q^5-1)*(q^2-1)
		div Gcd(3, q-1) where q is tup[3];
	when 8: return q^63*(q^18-1)*(q^14-1)*(q^12-1)*(q^10-1)*(q^8-1)*(q^6-1)*
	    (q^2-1) div Gcd(3, q-1) where q is tup[3];
	when 9: return q^120*(q^30-1)*(q^24-1)*(q^20-1)*(q^18-1)*(q^14-1)*
	    (q^12-1)*(q^8-1)*(q^2-1) where q is tup[3];
	when 10: return (q^(n*(n+1) div 2) * &*[q^i- (-1)^i:i in [2..n+1]]) div
		    Gcd(n+1, q+1) where q is tup[3] where n is tup[2];
	when 11: return q^2*(q^2+1)*(q-1) where q is tup[3];
	when 12: return (q^(n*(n-1))*(q^n+1)* &*[q^i-1: i in [2..2*n-2 by 2]]) 
		    div Gcd(4, q^n+1) where q is tup[3] where n is tup[2];
	when 13: return q^12*(q^8+q^4+1)*(q^6-1)*(q^2-1) where q is tup[3];
	when 14: return q^3*(q^3+1)*(q-1) where q is tup[3];
	when 15: N :=  q^12*(q^6+1)*(q^4-1)*(q^3+1)*(q-1) where q is tup[3];
	    if tup[3] eq 2 then N div:= 2; end if; return N;
	when 16: return q^36*(q^12-1)*(q^9+1)*(q^8-1)*(q^6-1)*(q^5+1)*(q^2-1)
		div Gcd(3, q+1) where q is tup[3];
    end case;
end function;

intrinsic SimpleGroupOrder(T::Tup) -> RngIntElt
{The order of the simple group specified by the tuple T. 
T is assumed to be a tuple as returned by IsSimpleOrder or as part of the 
sequence returned by CompositionFactors}
 
    return simple_order(T);
end intrinsic;

intrinsic HasComputableSubgroups(G::Grp) -> BoolElt
{Can the Subgroups family of functions be applied to G}

    if ISA(Category(G), GrpPC) then return true; end if;

    if not ISA(Category(G), GrpPerm) then
	 if ISA(Category(G), GrpMat) then
	     if not IsFinite(G) then return false; end if;
	     K := BaseRing(G);
	     if not (IsField(K) or IsDomain(K) or Type(K) eq RngIntRes) then
		return false;
	    end if;
	 else
	     return false;
	 end if;
    end if;

    if #G le 16000000 then 
	return true; 
    end if;

    cf := Seqset(CompositionFactors(G));
    D := AlmostSimpleGroupDatabase();

    for c in cf do
	if c[1] eq 19 then continue; end if; //prime order
	if c[1] eq 17 and c[2] le 2499 then continue; end if; //alternating
	if c[3] gt 0 then fac := Factorisation(c[3]); end if;
	if c[1] eq 1 and c[2] le 6  then 
	    continue; // L(2,q), L(3,q), L(4,q), L(5,q), L(6,q), L(7,q)
	end if; 
	if c[1] eq 1 and c[2] lt 14 and c[3] eq 2 then
	    continue;	// L(d,2), d <= 14
	end if;
	if c[1] eq 10 and c[2] le 3  then
		continue; // U(3,q), U(4,q)
	end if;
	if c[1] eq 3 and c[2] eq 2 then 
	    continue; // S(4,q)
	end if;
	o := simple_order(c);
	if o le 16000000 then
	    continue;
	end if;
	// trap the extras
	if o in {17971200, // Tits'
		174182400, // O+(8,2)
		197406720, // O-(8,2)
		211341312, // 3D4(2)
		251596800, //G24
		4030387200, // He
		4585351680, //S63 or O73
		5859000000, //G25
		9196830720, //U62
		47377612800, // S82
		145926144000, // Ru
		448345497600, // Suz
		495766656000, // Co3
		10151968619520, // O-(8,3)
		23499295948800, //O+(10,2)
		25015379558400, //O-(10,2)
		42305421312000, // Co2
		64561751654400, // Fi22
		24815256521932800 // S(10,2)
		} then continue; end if;
	if not ExistsGroupData(D, o, o) then return false; end if;
    end for;
    return true;
end intrinsic;

intrinsic ChiefFactorsToString(Q::SeqEnum[Tup]) -> MonStgElt
{A string representing the chief factors sequence Q}
    str := "";
    for i := #Q to 1 by -1 do
	t := Q[i];
	s := <t[1],t[2],t[3]>;
	str cat:= simple_short_name(s);
	if t[4] gt 1 then 
	    str cat:= "^";
	    str cat:= IntegerToString(t[4]);
	end if;
	if i gt 1 then str cat:= "."; end if;
    end for;
    return str;
end intrinsic;

delete sporadic_orders, simple_order;

