freeze;

import "../../recformat.m": SporadicRF;
import "../../List.m": ListMaximals;
import "../../BlackBoxes/Autm/J3.m":StandardGeneratorsJ3Autm;

/* generators for maximal subgroups of J3:2 */

GeneratorsJ3AutmMax1 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w2;
w5:=w3*w4;
w1:=w3^12;
w4:=w5^-1;
w3:=w4*w2;
w2:=w3*w5;

   return [w1,w2];
end function;

GeneratorsJ3AutmMax2 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w2;
w5:=w4*w4;
w1:=w4*w3;
w4:=w1*w5;
w1:=w3^3;
w3:=w1*w1;
w5:=w4*w1;
w1:=w3*w5;

   return [w1,w2];

end function;

GeneratorsJ3AutmMax3 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w2;
w5:=w4*w3;
w6:=w5*w5;
w5:=w6*w1;
w6:=w3*w4;
w4:=w3*w6;
w6:=w4*w4;
w1:=w6*w5;

   return [w1,w2];

end function;

GeneratorsJ3AutmMax4 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w2;
w2:=w3^5;
w3:=w4^4;
w5:=w2*w3;
w2:=w4*w5;

   return [w1,w2];

end function;

GeneratorsJ3AutmMax5 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w2;
w5:=w4*w3;
w2:=w5*w3;
w5:=w4^3;
w4:=w3*w5;
w5:=w4*w4;
w4:=w5*w2;
w2:=w3*w4;

   return [w1,w2];

end function;

GeneratorsJ3AutmMax6 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w2;
w5:=w3*w4;
w2:=w4^4;
w4:=w2*w3;
w2:=w3*w3;
w3:=w5*w2;
w2:=w3*w4;

   return [w1,w2];

end function;

GeneratorsJ3AutmMax7 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w2;
w5:=w3*w4;
w2:=w3^4;
w3:=w2*w5;
w4:=w5*w2;
w2:=w3*w4;

   return [w1,w2];

end function;

GeneratorsJ3AutmMax8 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w2;
w5:=w3*w4;
w2:=w4*w4;
w4:=w2*w3;
w2:=w3^6;
w3:=w5*w2;
w2:=w3*w4;

   return [w1,w2];

end function;

GeneratorsJ3AutmMax9 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w2;
w5:=w3*w4;
w2:=w5*w5;
w5:=w4*w4;
w4:=w3^6;
w3:=w2*w4;
w2:=w3*w5;

   return [w1,w2];

end function;

/* list of subgroups of J3:2 */

DataJ3Autm := function ()

   F<a, b> := SLPGroup (2);
   
   L := [
   rec <SporadicRF | name := "J3:2", generators := [a, b], order := 100465920>,
   
   rec <SporadicRF | name := "J3", parent := "J3:2", generators := 
   GeneratorsJ3AutmMax1(a,b), order := 50232960, index := 2>,
   
   rec <SporadicRF | name := "PSL(2,16):4", parent := "J3:2", generators := 
   GeneratorsJ3AutmMax2(a,b), order := 16320, index := 6156>,
   
   rec <SporadicRF | name := "2^4:(3xA5).2", parent := "J3:2", generators := 
   GeneratorsJ3AutmMax3(a,b), order := 5760, index := 17442>,
   
   rec <SporadicRF | name := "PSL(2,17)x2", parent := "J3:2", generators := 
   GeneratorsJ3AutmMax4(a,b), order := 4896, index := 20520>,
   
   rec <SporadicRF | name := "(3xM10):2", parent := "J3:2", generators := 
   GeneratorsJ3AutmMax5(a,b), order := 4320, index := 23256>,
   
   rec <SporadicRF | name := "3^{2+1+2}:8.2", parent := "J3:2", generators := 
   GeneratorsJ3AutmMax6(a,b), order := 3888, index := 25840>,
   
   rec <SporadicRF | name := "2^{1+4}:S5", parent := "J3:2", generators := 
   GeneratorsJ3AutmMax7(a,b), order := 3840, index := 26163>,
   
   rec <SporadicRF | name := "2^{2+4}:(S3xS3)", parent := "J3:2", generators := 
   GeneratorsJ3AutmMax8(a,b), order := 2304, index := 43605>,
   
   rec <SporadicRF | name := "19:18", parent := "J3:2", generators := 
   GeneratorsJ3AutmMax9(a,b), order := 342, index := 293760>

   ];
   
   return L;

  
end function;

/* code to find standard generators of J3:2 and produce listing of maximal subgroups */

MaximalsJ3Autm := function (G)

   x, y := StandardGeneratorsJ3Autm(G);
   if Type(x) eq BoolElt then "Unable to find Standard Generators"; return false; end if;

   G := sub<G|x[1],x[2]>;
   return ListMaximals(G, "J3:2", DataJ3Autm());

end function;

