freeze;

import "../../recformat.m": SporadicRF;
import "../../List.m": ListMaximals;
import "../../BlackBoxes/Autm/ON.m":StandardGeneratorsONAutm;

/* generators for maximal subgroups of ON.2 */

GeneratorsONAutmMax1 := function (a,b)

   w1 := a; w2 := b;

w3:=w2*w2;
w4:=w1*w3;
w5:=w4*w4;
w6:=w5^-1;
w7:=w3*w5;
w1:=w6*w7;

   return [w1,w2];

end function;

/* list of subgroups of ON.2 */

DataONAutm := function ()

   F<a, b> := SLPGroup (2);
   
   L := [
   rec <SporadicRF | name := "ON:2", generators := [a, b], order := 921631011840>,
   
   rec <SporadicRF | name := "ON", parent := "ON:2", generators := 
   GeneratorsONAutmMax1(a,b), order := 460815505920, index := 2>

   ];
   
   return L;
   
end function;

/* code to find standard generators of ON:2 and produce 
   listing of maximal subgroups */

MaximalsONAutm := function (G)

   x, y := StandardGeneratorsONAutm(G);
   if Type(x) eq BoolElt then "Unable to find Standard Generators"; return false; end if;

   G := sub<G|x[1],x[2]>;
   return ListMaximals(G, "ON:2", DataONAutm());

end function;
