freeze;

import "../recformat.m":SporadicRF;
/* generators for maximal subgroups of O10p2 */

// BBOX converted automatically from
// http://brauer.maths.qmul.ac.uk/Atlas/clas/O10p2/words/O10p2G1-max1W1
GeneratorsO10p2Max1 := function(S)
  // WARNING! This is not an SLP!
  w1 := S[1];
  w2 := S[2];
  w3 := w2 * w1;
  w4 := w3 * w3;
  w3 := w2^3;
  w2 := w4 * w3;
  return [w1,w2];
end function;

// BBOX converted automatically from
// http://brauer.maths.qmul.ac.uk/Atlas/clas/O10p2/words/O10p2G1-max2W1
GeneratorsO10p2Max2 := function(S)
  // WARNING! This is not an SLP!
  w1 := S[1];
  w2 := S[2];
  w3 := w2^3;
  w4 := w3 * w1;
  w5 := w4 * w3;
  w3 := w2 * w5;
  w2 := w3 * w5;
  return [w1,w2];
end function;


// BBOX converted automatically from
// http://brauer.maths.qmul.ac.uk/Atlas/clas/O10p2/words/O10p2G1-max3W1
GeneratorsO10p2Max3 := function(S)
  // WARNING! This is not an SLP!
  w1 := S[1];
  w2 := S[2];
  w3 := w2 * w2;
  w4 := w2^17;
  w5 := w3 * w1;
  w2 := w5 * w4;
  return [w1,w2];
end function;

// BBOX converted automatically from
// http://brauer.maths.qmul.ac.uk/Atlas/clas/O10p2/words/O10p2G1-max4W1
GeneratorsO10p2Max4 := function(S)
  // WARNING! This is not an SLP!
  w1 := S[1];
  w2 := S[2];
  w3 := w2 * w2;
  w4 := w2^17;
  w5 := w4 * w1;
  w2 := w5 * w3;
  return [w1,w2];
end function;


  
/* list of subgroups of A7 */

DataO10p2 := function ()

   F<a, b> := SLPGroup (2);
   
   L := [
   rec <SporadicRF | name := "O10p2", generators := [a, b], 
       order := 23499295948800>,
   
   rec <SporadicRF | name := "S82", parent := "O10p2", generators := 
   GeneratorsO10p2Max1([a,b]), order := 47377612800, index := 496>,

   rec <SporadicRF | name := "2^8:O8p2", parent := "O10p2", generators := 
   GeneratorsO10p2Max2([a,b]), order := 44590694400, index := 527>,

   rec <SporadicRF | name := "2^10:L52", parent := "O10p2", generators := 
   GeneratorsO10p2Max3([a,b]), order := 10239344640, index := 2295>,

   rec <SporadicRF | name := "2^10:L52", parent := "O10p2", generators := 
   GeneratorsO10p2Max4([a,b]), order := 10239344640, index := 2295>
       
   ];
   
   return L;
   
end function;
